> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Personal Access Token

> Gets details about a specific personal access token.

`Unary` · [`Users`](/docs/api-reference/generated/user/overview)

Gets details about a specific personal access token.

Use this method to:

* View token metadata
* Check token expiration
* Monitor token usage

### Examples

* Get token details:

  Retrieves information about a specific token.

  ```yaml theme={null}
  personalAccessTokenId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.UserService/GetPersonalAccessToken
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.UserService/GetPersonalAccessToken" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "personalAccessTokenId": "<redacted>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.user_pb2 as user_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = user_pb2.GetPersonalAccessTokenRequest(
      personal_access_token_id="<redacted>",
  )
  response = ona.services.user.get_personal_access_token(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { GetPersonalAccessTokenRequestSchema } from "@gitpod/sdk/gitpod/v1/user_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(GetPersonalAccessTokenRequestSchema, {
      personalAccessTokenId: "<redacted>",
    });
    const response = await ona.services.user.getPersonalAccessToken(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.GetPersonalAccessTokenRequest{
  		PersonalAccessTokenId: "<redacted>",
  	})
  	response, err := ona.Services.User.GetPersonalAccessToken(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "personalAccessTokenId": "<redacted>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.GetPersonalAccessTokenRequest`

| Field                   | Type   | Required | Description                      |
| ----------------------- | ------ | -------- | -------------------------------- |
| `personalAccessTokenId` | string | No       | Constraints: `string.uuid=true`. |

## Response

`gitpod.v1.GetPersonalAccessTokenResponse`

| Field | Type                                                         | Required | Description                   |
| ----- | ------------------------------------------------------------ | -------- | ----------------------------- |
| `pat` | [PersonalAccessToken](#type-gitpod-v1-personal-access-token) | Yes      | Constraints: `required=true`. |

## Related types

<a id="type-gitpod-v1-personal-access-token" />

<Accordion title="PersonalAccessToken">
  `gitpod.v1.PersonalAccessToken`

  | Field         | Type                               | Required | Description                                                                                            |
  | ------------- | ---------------------------------- | -------- | ------------------------------------------------------------------------------------------------------ |
  | `id`          | string                             | No       | Constraints: `string.uuid=true`.                                                                       |
  | `userId`      | string                             | No       | Constraints: `string.uuid=true`.                                                                       |
  | `description` | string                             | No       |                                                                                                        |
  | `creator`     | [Subject](#type-gitpod-v1-subject) | No       |                                                                                                        |
  | `createdAt`   | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `expiresAt`   | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `lastUsed`    | RFC 3339 timestamp                 | No       |                                                                                                        |
  | `readOnly`    | boolean                            | No       | When true, the token can only be used for read operations. Mutations will be denied at the data layer. |
</Accordion>

<a id="type-gitpod-v1-subject" />

<Accordion title="Subject">
  `gitpod.v1.Subject`

  | Field       | Type                                   | Required | Description                                                                      |
  | ----------- | -------------------------------------- | -------- | -------------------------------------------------------------------------------- |
  | `id`        | string                                 | No       | id is the UUID of the subject Constraints: `ignore=1, string.uuid=true`.         |
  | `principal` | [Principal](#enum-gitpod-v1-principal) | No       | Principal is the principal of the subject Constraints: `enum.defined_only=true`. |
</Accordion>

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>
